function love.load()
	love.physics.setMeter(24)
	world = love.physics.newWorld( 0 * 64, 9 * 64, true )
	world:setCallbacks( beginContact, endContact, preSolve, postSolve )
	
	objects = {}
	
	objects.groundDown = {}
	objects.groundDown.body = love.physics.newBody( world, 800/2, 600, "static" )
	objects.groundDown.shape = love.physics.newRectangleShape( 800, 100 )
	objects.groundDown.fixture = love.physics.newFixture( objects.groundDown.body, objects.groundDown.shape, 1 )
	objects.groundDown.fixture:setUserData("Down")
	
	objects.groundUp = {}
	objects.groundUp.body = love.physics.newBody( world, 800/2, 0, "static" )
	objects.groundUp.shape = love.physics.newRectangleShape( 800, 100 )
	objects.groundUp.fixture = love.physics.newFixture( objects.groundUp.body, objects.groundUp.shape, 1 )
	objects.groundUp.fixture:setUserData("Up")
	
	objects.groundLeft = {}
	objects.groundLeft.body = love.physics.newBody( world, 0, 600/2, "static" )
	objects.groundLeft.shape = love.physics.newRectangleShape( 100, 600 )
	objects.groundLeft.fixture = love.physics.newFixture( objects.groundLeft.body, objects.groundLeft.shape, 1 )
	objects.groundLeft.fixture:setUserData("Left")
	
	objects.groundRight = {}
	objects.groundRight.body = love.physics.newBody( world, 800, 600/2, "static" )
	objects.groundRight.shape = love.physics.newRectangleShape( 100, 600 )
	objects.groundRight.fixture = love.physics.newFixture( objects.groundRight.body, objects.groundRight.shape, 1 )
	objects.groundRight.fixture:setUserData("Right")
	
	objects.block = {}
	objects.block.body = love.physics.newBody( world, 700, 400, "static" )
	objects.block.shape = love.physics.newRectangleShape( 300, 50 )
	objects.block.fixture = love.physics.newFixture( objects.block.body, objects.block.shape, 1 )
	objects.block.fixture:setUserData("Block")
	
	objects.block2 = {}
	objects.block2.body = love.physics.newBody( world, 100, 250, "static" )
	objects.block2.shape = love.physics.newRectangleShape( 300, 50 )
	objects.block2.fixture = love.physics.newFixture( objects.block2.body, objects.block2.shape, 1 )
	objects.block2.fixture:setUserData("Block2")
	
	objects.ball = {}
	objects.ball.body = love.physics.newBody( world, 200, 600/2, "dynamic" )
	objects.ball.shape = love.physics.newRectangleShape( 32, 32 )
	objects.ball.fixture = love.physics.newFixture( objects.ball.body, objects.ball.shape, 1 )
	objects.ball.fixture:setUserData("Player")
	
	text = ""
end

function love.update(dt)
	dirLeftWE = love.joystick.getAxis( 1, 1 )
	dirLeftNS = love.joystick.getAxis( 1, 2 )
	
	worldTime = love.timer.getTime(dt)
	world:update(dt)
	
	if love.keyboard.isDown("lshift") then
		if love.keyboard.isDown("left") then
			objects.ball.body:applyForce( -600, 0 )
		end
		if love.keyboard.isDown("right") then
			objects.ball.body:applyForce( 600, 0 )
		end
	else
		if love.keyboard.isDown("left") then
			objects.ball.body:applyForce( -400, 0 )
		end
		if love.keyboard.isDown("right") then
			objects.ball.body:applyForce( 400, 0 )
		end
	end
	
	if jumpEnabled == true then
		if love.keyboard.isDown(" ") then
		objects.ball.body:applyLinearImpulse( 0, -400 )
		end
	elseif jumpEnabled == false then
	
	end
	if love.joystick.isDown( 1, 3 ) then
		if dirLeftWE < -0.2 then
			objects.ball.body:applyForce( -600, 0 )
		end
		if dirLeftWE > 0.2 then
			objects.ball.body:applyForce( 600, 0 )
		end
	else
		if dirLeftWE < -0.2 then
			objects.ball.body:applyForce( -400, 0 )
		end
		if dirLeftWE > 0.2 then
			objects.ball.body:applyForce( 400, 0 )
		end
		if dirLeftWE < -0.2 and dirLeftWE > 0.2 then
			objects.ball.body:applyForce( 0, 0 )
		end
	end
	if jumpEnabled == true then
		if love.joystick.isDown( 1, 1 ) then
			objects.ball.body:applyLinearImpulse( 0, -400 )
		end
	elseif jumpEnabled == false then
	
	end
end

function love.draw()
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.polygon( "fill", objects.groundDown.body:getWorldPoints(objects.groundDown.shape:getPoints()))
	
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.polygon( "fill", objects.groundUp.body:getWorldPoints(objects.groundUp.shape:getPoints()))
	
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.polygon( "fill", objects.groundLeft.body:getWorldPoints(objects.groundLeft.shape:getPoints()))
	
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.polygon( "fill", objects.groundRight.body:getWorldPoints(objects.groundRight.shape:getPoints()))
	
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.polygon( "fill", objects.block.body:getWorldPoints(objects.block.shape:getPoints()))
	
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.polygon( "fill", objects.block2.body:getWorldPoints(objects.block2.shape:getPoints()))
	
	love.graphics.setColor( 255, 0, 0 )
	love.graphics.polygon( "fill", objects.ball.body:getWorldPoints(objects.ball.shape:getPoints()))
	
	love.graphics.setColor( 0, 0, 0 )
	love.graphics.print( worldTime, 5, 600-15, 0, 1, 1, 0, 0 )
	love.graphics.print( text, 5, 600-45, 0, 1, 1, 0, 0 )
	
	love.graphics.print( objects.ball.body:getX() .. ", " .. objects.ball.body:getY(), 5, 600-30, 0, 1, 1, 0, 0 )
end


function beginContact(a, b, coll)
	local x, y = coll:getNormal()
	text = a:getUserData() .. " is touching " .. b:getUserData() .. " at " .. x .. ", " .. y
	jumpEnabled = true
end

function endContact(a, b, coll)
	text = ""
	jumpEnabled = false
end

function preSolve(a, b, coll)
	if a:getUserData() == "Left" or a:getUserData() == "Right" then
		jumpEnabled = false
	end
end
function postSolve(a, b, coll)

end